bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[PATCH] tail: flush initial output before possibly blocking


From: Jim Meyering
Subject: [PATCH] tail: flush initial output before possibly blocking
Date: Sun, 06 Sep 2009 10:31:44 +0200

I noticed that tail -f "didn't work" when run via ssh.
I.e., it printed nothing, when I expected it to print the
last 10 lines.

It was due to a missing flush.
I could have moved the existing fflush (at end of tail_forever_inotify)
"up" to precede the potentially blocking syscalls, but that would have
made tail call it for every iteration, including some for which it would
be unnecessary.


>From d54376db68adf655b5f09855442b2983fc2f4f3e Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Sun, 6 Sep 2009 09:39:31 +0200
Subject: [PATCH] tail: flush initial output before possibly blocking

* src/tail.c (main): Flush any output from tail_file,
before calling tail_forever_inotify, which can block.
* tests/tail-2/flush-initial: New file.  Test for the bug.
* tests/Makefile.am (TESTS): Add tail-2/flush-initial.
* NEWS (Bug fixes): Mention it.
This bug was introduced in coreutils-7.5 via commit ae494d4b,
2009-06-02, "tail: use inotify if it is available".
---
 NEWS                       |    5 +++++
 src/tail.c                 |    7 ++++++-
 tests/Makefile.am          |    1 +
 tests/tail-2/flush-initial |   41 +++++++++++++++++++++++++++++++++++++++++
 4 files changed, 53 insertions(+), 1 deletions(-)
 create mode 100755 tests/tail-2/flush-initial

diff --git a/NEWS b/NEWS
index cb01227..b02d2da 100644
--- a/NEWS
+++ b/NEWS
@@ -27,6 +27,11 @@ GNU coreutils NEWS                                    -*- 
outline -*-
   because ls must stat every file in order to obtain a guaranteed-valid
   inode number.  [bug introduced in coreutils-6.0]

+  tail -f (inotify-enabled) now flushes any initial output before blocking.
+  Before, this would print nothing and wait: stdbuf -o 4K tail -f /etc/passwd
+  Note that this bug affects tail -f only when its standard output is buffered,
+  which is relatively unusual.
+
 ** New features

   cp --reflink accepts a new "auto" parameter which falls back to
diff --git a/src/tail.c b/src/tail.c
index fee3f1f..e3b9529 100644
--- a/src/tail.c
+++ b/src/tail.c
@@ -1399,7 +1399,6 @@ tail_forever_inotify (int wd, struct File_spec *f, size_t 
n_files,
       if (fflush (stdout) != 0)
         error (EXIT_FAILURE, errno, _("write error"));
     }
-
 }
 #endif

@@ -1990,6 +1989,12 @@ main (int argc, char **argv)
             error (0, errno, _("inotify cannot be used, reverting to 
polling"));
           else
             {
+              /* Flush any output from tail_file, now, since
+                 tail_forever_inotify flushes only after writing,
+                 not before reading.  */
+              if (fflush (stdout) != 0)
+                error (EXIT_FAILURE, errno, _("write error"));
+
               tail_forever_inotify (wd, F, n_files, sleep_interval);

               /* The only way the above returns is upon failure.  */
diff --git a/tests/Makefile.am b/tests/Makefile.am
index d9ff95b..d83d41b 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -427,6 +427,7 @@ TESTS =                                             \
   rmdir/t-slash                                        \
   tail-2/assert-2                              \
   tail-2/big-4gb                               \
+  tail-2/flush-initial                         \
   tail-2/proc-ksyms                            \
   tail-2/start-middle                          \
   touch/dangling-symlink                       \
diff --git a/tests/tail-2/flush-initial b/tests/tail-2/flush-initial
new file mode 100755
index 0000000..2deff84
--- /dev/null
+++ b/tests/tail-2/flush-initial
@@ -0,0 +1,41 @@
+#!/bin/sh
+# inotify-based tail -f didn't flush its initial output before blocking
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  tail --version
+fi
+
+. $srcdir/test-lib.sh
+
+fail=0
+echo line > in || fail=1
+stdbuf --output=1K tail -f in > out &
+tail_pid=$!
+
+# Wait for the backgrounded `tail' to start.
+while :; do
+  env kill -0 $tail_pid && break
+  sleep .1
+done
+
+test -s out || fail=1
+
+kill $tail_pid
+
+Exit $fail
--
1.6.4.2.409.g85dc3




reply via email to

[Prev in Thread] Current Thread [Next in Thread]